#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stropts.h>
#include "physmap.h"
#include  <sys/mman.h>

int main(int argc,char **argv)
{
        uint32_t *test;
	int fd;
	int i;
	struct physmap_info myinfo;

	if(!(argv[1])){
	  fprintf(stderr,"You need to supply the physmap device file.\n");
	  fprintf(stderr,"It will typically be situated in a directory named\n");
	  fprintf(stderr,"something like /devices/pci@0,0/pci8086,7191@1\n");
	  exit(1);
	}
	fd=open(argv[1],O_RDWR);
	if(fd==-1){
	  perror("open()");
	  exit(1);
	}

	ioctl(fd,PHYSMAP_GETINFO,&myinfo);
	
	printf("Slice phys is 0x%x\n",myinfo.slice_phys);
	printf("Sice size is 0x%x\n",myinfo.largest_slice);
	printf("Total regionsize is 0x%x\n",myinfo.regionsize);

	if(myinfo.allow_detach){
	  printf("The physmap module can be unloaded\n");
	}else{
	  printf("The physmap module cannot be unloaded\n");
	}

	exit(0);
}
